package shoppingcart;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import shoppingcart.common.*;

//J[g̕\
public class ShopCart extends BaseServlet {

    protected Context getContext(HttpServletRequest req) {
        Context cont = getMyContext("myContext", req);
        cont.dbAccess = false;
        return cont;
    }

    protected void action(HttpServletRequest req,
                HttpServletResponse res, Context cont) {
        UserContext myContext = (UserContext)cont;
        int index = 0;
        if (req.getParameter("index") != null){
            index = Integer.parseInt(getParameter("index", req));
        }
        //J[g̎ws̐ʂύX
        if ("modify".equals(getParameter("action", req))){
            //
            if (isNumber(getParameter("qty", req))){
                CartRecord cr = (CartRecord)myContext.cart.get(index);
                cr.setQty(getParameter("qty", req));
            }
            //
        }
        //J[g̎ws폜
        if ("delete".equals(getParameter("action", req))){
            myContext.cart.remove(index);
        }
        //J[g̍vz擾AContextɊi[
        myContext.totalPrice = getTotalPrice(myContext);
    }

    protected void setPage(Context myContext) {
        myContext.nextPage = "/ShoppingCart/cart.jsp";
    }

    protected void setErrorPage(Context myContext) {
        myContext.nextPage = "/servlet/shoppingcart.ProdList";
    }

    //J[g̍vz擾
    private long getTotalPrice(UserContext myContext){
        long result = 0;
        for(int i=0; i<myContext.cart.size(); i++){
            CartRecord cr = (CartRecord)myContext.cart.get(i);
            if (cr.getPrice() != null && cr.getQty() != null){
                result += Long.parseLong(cr.getPrice()) * 
                        Long.parseLong(cr.getQty());
            }
        }
        return result;
    }
}
